diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/improvement.h freeciv-patched/common/improvement.h
--- freeciv-cvs/common/improvement.h	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/improvement.h	2003-06-30 12:18:17.000000000 +0100
@@ -21,6 +21,7 @@
 #include "unittype.h"		/* Unit_Class_id, Unit_Type_id */
 
 struct player;
+struct map_position;
 
 
 /* Improvement types.
@@ -44,9 +45,9 @@
 #ifdef OLD_IMPR_TYPE_ENUM
 enum improvement_type_id {
   B_AIRPORT=0, B_AQUEDUCT, B_BANK, B_BARRACKS, B_BARRACKS2, B_BARRACKS3, 
-  B_CATHEDRAL, B_CITY, B_COASTAL, B_COLOSSEUM, B_COURTHOUSE,  B_FACTORY, 
+  B_CATHEDRAL, B_orCITY, B_COASTAL, B_COLOSSEUM, B_COURTHOUSE,  B_FACTORY, 
   B_GRANARY, B_HARBOUR, B_HYDRO, B_LIBRARY, B_MARKETPLACE, B_MASS, B_MFG, 
-  B_NUCLEAR, B_OFFSHORE, B_PALACE, B_POLICE, B_PORT, B_POWER,
+  B_NUCLEAR, B_OFFSHORE, B_orPALACE, B_POLICE, B_PORT, B_POWER,
   B_RECYCLING, B_RESEARCH, B_SAM, B_SDI, B_SEWER, B_SOLAR, B_SCOMP, 
   B_SMODULE, B_SSTRUCTURAL, B_STOCK, B_SUPERHIGHWAYS, B_SUPERMARKET, B_TEMPLE,
   B_UNIVERSITY,  
@@ -60,6 +61,11 @@
 };
 #endif
 
+/* Some code checks explicitly for City Walls or Palace - as a temporary
+   fix, set these to the indices of improvements which provide the
+   EFT_UNIT_DEFEND (aff_unit=Land) and EFT_CAPITAL_CITY effects */
+extern int B_CITY, B_PALACE;
+
 /* B_LAST is a value which is guaranteed to be larger than all
  * actual Impr_Type_id values.  It is used as a flag value;
  * it can also be used for fixed allocations to ensure ability
@@ -77,11 +83,14 @@
   IR_LAST      /* keep this last */
 };
 
+#define B_NATION (B_LAST + 1)
+#define B_GOV    (B_LAST + 2)
+
 /* Range of effects (used in equiv_range and effect.range fields)
  * These must correspond to effect_range_names[] in improvement.c. */
 enum effect_range {
   EFR_NONE,
-  EFR_BUILDING,
+  EFR_LOCAL,
   EFR_CITY,
   EFR_ISLAND,
   EFR_PLAYER,
@@ -121,21 +130,21 @@
   EFT_NO_SINK_DEEP,
   EFT_NUKE_PROOF,
   EFT_POLLU_ADJ,
-  EFT_POLLU_ADJ_POP,
-  EFT_POLLU_ADJ_PROD,
-  EFT_POLLU_SET,
-  EFT_POLLU_SET_POP,
-  EFT_POLLU_SET_PROD,
+  EFT_POLLU_POP_ADJ,
+  EFT_POLLU_PROD_ADJ,
+  EFT_POLLU_PCT,
+  EFT_POLLU_POP_PCT,
+  EFT_POLLU_PROD_PCT,
   EFT_PROD_ADD_TILE,
   EFT_PROD_BONUS,
   EFT_PROD_INC_TILE,
   EFT_PROD_PER_TILE,
   EFT_PROD_TO_GOLD,
-  EFT_REDUCE_CORRUPT,
-  EFT_REDUCE_WASTE,
+  EFT_CORRUPT_ADJ,
+  EFT_CORRUPT_PCT,
   EFT_REVEAL_CITIES,
   EFT_REVEAL_MAP,
-  EFT_REVOLT_DIST,
+  EFT_REVOLT_DIST_ADJ,
   EFT_SCIENCE_BONUS,
   EFT_SCIENCE_PCT,
   EFT_SIZE_UNLIMIT,
@@ -163,6 +172,21 @@
   EFT_UPGRADE_ALL_STEP,
   EFT_UPGRADE_ALL_LEAP,
   EFT_UPKEEP_FREE,
+  EFT_FOOD_PCT,
+  EFT_PROD_PCT,
+  EFT_REVOLT_DIST_PCT,
+  EFT_TRADE_PCT,
+  EFT_MAKE_CONTENT_MIL_PER,
+  EFT_FORCE_CONTENT,
+  EFT_FORCE_CONTENT_PCT,
+  EFT_FORCE_HAPPY,
+  EFT_UNIT_ATTACK,
+  EFT_UNIT_ATTACK_FIREPOWER,
+  EFT_UNIT_DEFEND_FIREPOWER,
+  EFT_UNIT_COST,
+  EFT_BUILDING_COST,
+  EFT_UNIT_COST_PCT,
+  EFT_BUILDING_COST_PCT,
   EFT_LAST	/* keep this last */
 };
 
@@ -172,6 +196,9 @@
   enum effect_range range;
   int amount;
   int survives;			   /* 1 = effect survives wonder destruction */
+  int outside;				/* 1 = effect influences units outside
+					 * of cities, not just those in the
+					 * center tile */
   Impr_Type_id cond_bldg;	   /* B_LAST = unconditional */
   int cond_gov;			   /* game.government_count = unconditional */
   Tech_Type_id cond_adv;	   /* A_NONE = unconditional; A_LAST = never */
@@ -181,10 +208,38 @@
   enum tile_special_type aff_spec; /* S_* bit mask of specials affected */
 };
 
+/* Status of a city's improvement effects
+ * (a bitfield: bit 0 set = first effect active, etc.) */
+typedef unsigned Eff_Status;
+
 /* Maximum number of effects per improvement 
  * (this should not be more than the number of bits in the Eff_Status type) */
 #define MAX_EFFECTS 16
 
+/* Keeps track of which improvement effects are active in a city.  */
+struct eff_city {
+  Impr_Type_id impr;  /* The ID of the improvement that confers the effects;
+		       * if B_LAST, then this instance is unused and ready
+		       * to be freed (or replaced with a new improvement);
+		       * if B_NATION or B_GOV, then the effects are not
+		       * from an improvement at all, but are conferred by
+		       * the nation or governement type */
+  Eff_Status active;  /* Which of the actual impr_effect effects are active */
+};
+
+/* Copy of eff_city effect activity for effects with Player-, Island-,
+ * and World- ranges */
+struct eff_global {
+  struct eff_city eff; /* Should be updated whenever the corresponding
+			* structure in the improvement's home city is
+			* modified. N.B. Keep this first in the structure
+			* so that a (struct eff_city) cast works */
+  int cityid;          /* ID of the city that owns the improvment (if -1,
+			* then the effect has survived the city destruction,
+			* and should therefore be placed in the savefile) */
+  struct player *plr;  /* Player that owns whatever confers this effect */
+};
+
 /* Type of improvement. (Read from buildings.ruleset file.) */
 struct impr_type {
   char name[MAX_LEN_NAME];
@@ -214,21 +269,144 @@
 
 extern struct impr_type improvement_types[B_LAST];
 
+/* get 'struct ceff_vector' and related functions: */
+#define SPECVEC_TAG ceff
+#define SPECVEC_TYPE struct eff_city
+#include "specvec.h"
+
+/* get 'struct geff_vector' and related functions: */
+#define SPECVEC_TAG geff
+#define SPECVEC_TYPE struct eff_global
+#include "specvec.h"
+
 /* impr range id/string converters */
 enum impr_range impr_range_from_str(const char *str);
 const char *impr_range_name(enum impr_range id);
 
+/* An iterator to look at the effects affecting a building/city/player. */
+struct eff_iter {
+  struct impr_effect *imeff;           /* The next active effect */
+  struct city *pcity;
+  struct player *pplayer;
+  Impr_Type_id impr;
+  struct ceff_vector *effs[EFR_LAST];
+  enum effect_range range;
+  int index;
+  Eff_Status bitmask;
+  Unit_Type_id utype;
+  struct unit_classes aff_unit;
+  enum tile_terrain_type aff_terr;
+  enum tile_special_type aff_spec;
+};
+
 /* improvement effect functions */
 enum effect_range effect_range_from_str(const char *str);
 const char *effect_range_name(enum effect_range id);
 enum effect_type effect_type_from_str(const char *str);
 const char *effect_type_name(enum effect_type id);
 
+void get_effect_vectors(struct ceff_vector *ceffs[],
+			struct geff_vector *geffs[],
+			Impr_Type_id impr, struct city *pcity);
+void get_all_effect_vectors(struct ceff_vector *effs[EFR_LAST],
+			    Impr_Type_id impr, struct city *pcity,
+			    int cont, struct player *plr);
+bool is_under_effect(Impr_Type_id impr, struct city *pcity,
+		     struct player *pplayer, enum effect_type cond_eff);
+bool is_effect_activated(Impr_Type_id impr, struct city *pcity,
+			 struct player *pplayer, struct impr_effect *imeff,
+			 bool *cond_eff);
+struct ceff_vector *get_geff_parent(struct geff_vector *geff);
+void update_global_effect(struct city *pcity, struct player *pplayer,
+			  struct eff_city *effect);
+struct eff_city *append_ceff(struct ceff_vector *x);
+struct eff_global *append_geff(struct geff_vector *x);
+void eff_iterator_impr_init(struct eff_iter *iter, Impr_Type_id impr,
+                            struct city *pcity, struct player *pplayer);
+void eff_iterator_unit_init(struct eff_iter *iter, Unit_Type_id utype,
+    			    Unit_Type_id aff_utype,
+                            struct player *pplayer, struct map_position *mp);
+struct impr_effect *eff_iterator_next(struct eff_iter *iter);
+struct impr_effect *eff_iterator_next_full(struct eff_iter *iter,
+                                           struct unit_classes *aff_unit,
+                                           enum tile_terrain_type aff_terr,
+                                           enum tile_special_type aff_spec);
+Impr_Type_id eff_iterator_get_improvement(struct eff_iter *iter);
+int is_unit_terrain_affected(struct impr_effect *imeff,
+    			     struct unit_classes *aff_unit,
+                             enum tile_terrain_type aff_terr,
+                             enum tile_special_type aff_spec);
+bool is_city_affected(struct impr_effect *imeff, struct city *pcity);
+bool is_effect_outside(struct impr_effect *imeff, struct city *pcity);
+
+#define city_effects_iterate(EI_iter, pcity) \
+  { \
+    struct eff_iter EI_iter; \
+    eff_iterator_impr_init(&EI_iter, B_LAST, pcity, city_owner(pcity)); \
+    while (eff_iterator_next(&EI_iter)) {
+
+#define city_effects_iterate_end \
+    } \
+  }
+
+#define city_effects_iterate_full(EI_iter, pcity, uclass, terr, spec) \
+  { \
+    struct eff_iter EI_iter; \
+    eff_iterator_impr_init(&EI_iter, B_LAST, pcity, city_owner(pcity)); \
+    while (eff_iterator_next_full(&EI_iter, uclass, terr, spec)) {
+
+#define city_effects_iterate_full_end \
+    } \
+  }
+
+#define impr_effects_iterate(EI_iter, impr, pcity, pplayer) \
+  { \
+    struct eff_iter EI_iter; \
+    eff_iterator_impr_init(&EI_iter, impr, pcity, pplayer); \
+    while (eff_iterator_next(&EI_iter)) {
+
+#define impr_effects_iterate_end \
+    } \
+  }
+
+#define impr_effects_iterate_full(EI_iter, impr, pcity, pplayer, uclass, terr, spec) \
+  { \
+    struct eff_iter EI_iter; \
+    eff_iterator_impr_init(&EI_iter, impr, pcity, pplayer); \
+    while (eff_iterator_next_full(&EI_iter, uclass, terr, spec)) {
+
+#define impr_effects_iterate_full_end \
+    } \
+  }
+
+#define unit_effects_iterate(EI_iter, punit, aff_unit) \
+  { \
+    struct eff_iter EI_iter; \
+    struct map_position EI_mappos; \
+    EI_mappos.x = (punit)->x; EI_mappos.y = (punit)->y; \
+    eff_iterator_unit_init(&iter, (punit)->type, (aff_unit)->type, unit_owner(punit), &EI_mappos); \
+    while (eff_iterator_next(&EI_iter)) {
+
+#define unit_effects_iterate_end \
+    } \
+  }
+
+#define unittype_effects_iterate(EI_iter, utype, aff_utype, pplayer, mappos) \
+  { \
+    struct eff_iter EI_iter; \
+    eff_iterator_unit_init(&iter, utype, aff_utype, pplayer, mappos); \
+    while (eff_iterator_next(&EI_iter)) {
+
+#define unittype_effects_iterate_end \
+    } \
+  }
+
 /* improvement functions */
 void improvements_free(void);
 struct impr_type *get_improvement_type(Impr_Type_id id);
 bool improvement_exists(Impr_Type_id id);
 int improvement_value(Impr_Type_id id);
+int improvement_value_adjusted(Impr_Type_id id, struct city *pcity);
 bool is_wonder(Impr_Type_id id);
 const char *get_improvement_name(Impr_Type_id id);
 
@@ -242,6 +420,11 @@
 bool is_wonder_useful(Impr_Type_id id);
 Impr_Type_id find_improvement_by_name(const char *s);
 void improvement_status_init(Impr_Status * improvements, size_t elements);
+Impr_Type_id get_improvement_for_effect(struct player *pplayer,
+                                        enum effect_type id,
+                                        struct unit_classes *aff_unit);
+struct impr_effect *get_base_effect(Impr_Type_id impr, struct player *pplayer);
+const char *get_effect_cause_name(Impr_Type_id impr, struct player *pplayer);
 
 /* player related improvement and unit functions */
 bool could_player_eventually_build_improvement(struct player *p, 
@@ -249,7 +432,15 @@
 bool can_player_build_improvement(struct player *p, Impr_Type_id id);
 
 /* city related improvement functions */
+void add_destroyed_improvement(struct player *p, Impr_Type_id id);
 void mark_improvement(struct city *pcity,Impr_Type_id id,Impr_Status status);
+struct geff_vector *get_eff_world(void);
+struct geff_vector *get_eff_player(struct player *plr);
+struct geff_vector *get_eff_island(int cont, struct player *plr);
+struct ceff_vector *get_eff_city(struct city *pcity);
+void remove_global_effects(Impr_Type_id impr, struct player *pplayer);
+void add_global_effects(Impr_Type_id impr, struct player *pplayer);
+
 void allot_island_improvs(void);
 void improvements_update_obsolete(void);
 void improvements_update_redundant(struct player *pplayer, struct city *pcity,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/map.c freeciv-patched/common/map.c
--- freeciv-cvs/common/map.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/map.c	2003-06-30 12:15:13.000000000 +0100
@@ -193,6 +193,7 @@
   map.separatepoles         = MAP_DEFAULT_SEPARATE_POLES;
   map.tiles                 = NULL;
   map.num_continents        = 0;
+  map.old_num_continents    = -1;
   map.num_start_positions   = 0;
   map.fixed_start_positions = FALSE;
   map.have_specials         = FALSE;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/map.h freeciv-patched/common/map.h
--- freeciv-cvs/common/map.h	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/map.h	2003-06-30 12:15:13.000000000 +0100
@@ -173,6 +173,7 @@
   bool have_huts;
   bool have_rivers_overlay;	/* only applies if !have_specials */
   int num_continents;
+  int old_num_continents;
   struct tile *tiles;
 
   /* Only used by server. */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/nation.c freeciv-patched/common/nation.c
--- freeciv-cvs/common/nation.c	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/common/nation.c	2003-06-30 12:18:03.000000000 +0100
@@ -208,6 +208,9 @@
   int i;
   struct nation_type *p = get_nation_by_idx(nation);
 
+  free(p->effect);
+  p->effect = NULL;
+
   for (i = 0; i < p->leader_count; i++) {
     free(p->leaders[i].name);
   }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/nation.h freeciv-patched/common/nation.h
--- freeciv-cvs/common/nation.h	2003-06-30 12:18:25.000000000 +0100
+++ freeciv-patched/common/nation.h	2003-06-30 12:18:03.000000000 +0100
@@ -36,6 +36,7 @@
 
 struct Sprite;			/* opaque; client-gui specific */
 struct player;
+struct impr_effect;
 
 enum advisor_type {ADV_ISLAND, ADV_MILITARY, ADV_TRADE, ADV_SCIENCE, ADV_FOREIGN, 
                    ADV_ATTITUDE, ADV_DOMESTIC, ADV_LAST};
@@ -98,6 +99,8 @@
   /* civilized was never implemented, but will be eventually. -- Syela */
   int advisors[ADV_LAST];   /* never implemented either. -- Syela */
 
+  struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+
   /* Following basically disabled -- Syela */
   /* Note the client doesn't use/have these. */
   struct {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.c freeciv-patched/common/packets.c
--- freeciv-cvs/common/packets.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/packets.c	2003-06-30 12:18:10.000000000 +0100
@@ -178,6 +178,13 @@
   return result;
 }
 
+static void dio_put_effects(struct data_out *dout,
+                            struct connection *pc,
+                            const struct impr_effect *effect);
+static void dio_get_effects(struct data_in *din,
+                            struct connection *pc,
+                            struct impr_effect **peff);
+
 /**************************************************************************
 presult indicates if there is more packets in the cache. We return result
 instead of just testing if the returning package is NULL as we sometimes
@@ -1053,7 +1060,11 @@
   for (i = 0; i < A_LAST /*game.num_tech_types */ ; i++)
     dio_put_uint8(&dout, pinfo->global_advances[i]);
   for (i = 0; i < B_LAST /*game.num_impr_types */ ; i++)
-    dio_put_uint16(&dout, pinfo->global_wonders[i]);
+    dio_put_sint16(&dout, pinfo->global_wonders[i]);
+  if (has_capability("impr_gen", pc->capability)) {
+    for (i = 0; i < B_LAST; i++)
+      dio_put_sint16(&dout, pinfo->destroyed_owner[i]);
+  }
 
   dio_put_uint8(&dout, pinfo->techpenalty);
   dio_put_uint8(&dout, pinfo->foodbox);
@@ -1101,7 +1112,14 @@
   for (i = 0; i < A_LAST /*game.num_tech_types */ ; i++)
     dio_get_uint8(&din, &pinfo->global_advances[i]);
   for (i = 0; i < B_LAST /*game.num_impr_types */ ; i++)
-    dio_get_uint16(&din, &pinfo->global_wonders[i]);
+    dio_get_sint16(&din, &pinfo->global_wonders[i]);
+  if (has_capability("impr_gen", pc->capability)) {
+    for (i = 0; i < B_LAST; i++)
+      dio_get_sint16(&din, &pinfo->destroyed_owner[i]);
+  } else {
+    for(i = 0; i < B_LAST; i++)
+      pinfo->destroyed_owner[i] = -1;
+  }
 
   dio_get_uint8(&din, &pinfo->techpenalty);
   dio_get_uint8(&din, &pinfo->foodbox);
@@ -1362,6 +1380,11 @@
 
   dio_put_uint32(&dout, req->turn_founded);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_uint8(&dout, req->buildflags);
+    dio_put_uint8(&dout, req->upkeep_free);
+  }
+
   for (data = 0; data < NUM_TRADEROUTES; data++) {
     if (req->trade[data] != 0) {
       dio_put_uint16(&dout, req->trade[data]);
@@ -1453,6 +1476,11 @@
 
   dio_get_uint32(&din, &packet->turn_founded);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_uint8(&din, &packet->buildflags);
+    dio_get_uint8(&din, &packet->upkeep_free);
+  }
+
   for (data = 0; data < NUM_TRADEROUTES; data++) {
     if (dio_input_remaining(&din) < 3)
       break;
@@ -1859,6 +1887,9 @@
   dio_put_uint8(&dout, packet->default_government);
   dio_put_uint8(&dout, packet->government_when_anarchy);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_uint8(&dout, packet->num_unit_flags);
+  }
   dio_put_uint8(&dout, packet->num_unit_types);
   dio_put_uint8(&dout, packet->num_impr_types);
   dio_put_uint8(&dout, packet->num_tech_types);
@@ -1905,6 +1936,11 @@
   dio_get_uint8(&din, &packet->default_government);
   dio_get_uint8(&din, &packet->government_when_anarchy);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_uint8(&din, &packet->num_unit_flags);
+  } else {
+    packet->num_unit_flags = F_LAST;
+  }
   dio_get_uint8(&din, &packet->num_unit_types);
   dio_get_uint8(&din, &packet->num_impr_types);
   dio_get_uint8(&din, &packet->num_tech_types);
@@ -1970,6 +2006,10 @@
   }
   dio_put_uint8(&dout, packet->pop_cost);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_effects(&dout, pc, packet->effect);
+  }
+
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
     dio_put_string(&dout, packet->helptext);
@@ -2030,6 +2070,13 @@
   }
   dio_get_uint8(&din, &packet->pop_cost);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_effects(&din, pc, &packet->effect);
+  } else {
+    packet->effect = fc_malloc(sizeof(struct impr_effect));
+    packet->effect[0].type = EFT_LAST;
+  }
+
   len = dio_input_remaining(&din);
   if (len > 0) {
     packet->helptext = fc_malloc(len);
@@ -2115,11 +2162,44 @@
 /**************************************************************************
 ...
 **************************************************************************/
+static void dio_put_effects(struct data_out *dout,
+                            struct connection *pc,
+                            const struct impr_effect *effect)
+{
+  const struct impr_effect *eff;
+  int count;
+
+  assert(effect != NULL);
+
+  for (count = 0, eff = effect; eff->type != EFT_LAST; count++, eff++) {
+    /* nothing */
+  }
+  
+  dio_put_uint8(dout, count);
+  for (eff = effect; eff->type != EFT_LAST; eff++) {
+    dio_put_uint8(dout, eff->type);
+    dio_put_uint8(dout, eff->range);
+    dio_put_sint16(dout, eff->amount);
+    dio_put_uint8(dout, eff->survives);
+    if (has_capability("impr_gen", pc->capability)) {
+      dio_put_uint8(dout, eff->outside);
+    }
+    dio_put_uint8(dout, eff->cond_bldg);
+    dio_put_uint8(dout, eff->cond_gov);
+    dio_put_uint8(dout, eff->cond_adv);
+    dio_put_uint8(dout, eff->cond_eff);
+    dio_put_uint8(dout, eff->aff_unit);
+    dio_put_uint8(dout, eff->aff_terr);
+    dio_put_uint16(dout, eff->aff_spec);
+  }
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 int send_packet_ruleset_building(struct connection *pc,
 			        const struct packet_ruleset_building *packet)
 {
-  struct impr_effect *eff;
-  int count;
   SEND_PACKET_START(PACKET_RULESET_BUILDING);
 
   dio_put_uint8(&dout, packet->id);
@@ -2143,24 +2223,8 @@
   dio_put_uint16(&dout, packet->build_cost);
   dio_put_uint8(&dout, packet->upkeep);
   dio_put_uint8(&dout, packet->sabotage);
-  for (count = 0, eff = packet->effect; eff->type != EFT_LAST;
-       count++, eff++) {
-    /* nothing */
-  }
-  dio_put_uint8(&dout, count);
-  for (eff = packet->effect; eff->type != EFT_LAST; eff++) {
-    dio_put_uint8(&dout, eff->type);
-    dio_put_uint8(&dout, eff->range);
-    dio_put_sint16(&dout, eff->amount);
-    dio_put_uint8(&dout, eff->survives);
-    dio_put_uint8(&dout, eff->cond_bldg);
-    dio_put_uint8(&dout, eff->cond_gov);
-    dio_put_uint8(&dout, eff->cond_adv);
-    dio_put_uint8(&dout, eff->cond_eff);
-    dio_put_uint8(&dout, eff->aff_unit);
-    dio_put_uint8(&dout, eff->aff_terr);
-    dio_put_uint16(&dout, eff->aff_spec);
-  }
+  dio_put_effects(&dout, pc, packet->effect);
+
   dio_put_uint8(&dout, packet->variant);	/* FIXME: remove when gen-impr obsoletes */
   dio_put_string(&dout, packet->name);
   
@@ -2183,10 +2247,42 @@
 /**************************************************************************
 ...
 **************************************************************************/
+static void dio_get_effects(struct data_in *din,
+                            struct connection *pc,
+                            struct impr_effect **peff)
+{
+  int count, inx;
+  struct impr_effect *effect;
+
+  dio_get_uint8(din, &count);
+  effect = fc_malloc((count + 1) * sizeof(struct impr_effect));
+  for (inx = 0; inx < count; inx++) {
+    dio_get_uint8(din, (int *)&(effect[inx].type));
+    dio_get_uint8(din, (int *)&(effect[inx].range));
+    dio_get_sint16(din, &(effect[inx].amount));
+    dio_get_uint8(din, &(effect[inx].survives));
+    if (has_capability("impr_gen", pc->capability)) {
+      dio_get_uint8(din, &(effect[inx].outside));
+    }
+    dio_get_uint8(din, &(effect[inx].cond_bldg));
+    dio_get_uint8(din, &(effect[inx].cond_gov));
+    dio_get_uint8(din, &(effect[inx].cond_adv));
+    dio_get_uint8(din, (int *)&(effect[inx].cond_eff));
+    dio_get_uint8(din, (int *)&(effect[inx].aff_unit));
+    dio_get_uint8(din, (int *)&(effect[inx].aff_terr));
+    dio_get_uint16(din, (int *)&(effect[inx].aff_spec));
+  }
+  effect[count].type = EFT_LAST;
+  *peff = effect;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 struct packet_ruleset_building *
 receive_packet_ruleset_building(struct connection *pc)
 {
-  int len, inx, count;
+  int len;
   RECEIVE_PACKET_START(packet_ruleset_building, packet);
 
   dio_get_uint8(&din, &packet->id);
@@ -2206,22 +2302,8 @@
   dio_get_uint16(&din, &packet->build_cost);
   dio_get_uint8(&din, &packet->upkeep);
   dio_get_uint8(&din, &packet->sabotage);
-  dio_get_uint8(&din, &count);
-  packet->effect = fc_malloc((count + 1) * sizeof(struct impr_effect));
-  for (inx = 0; inx < count; inx++) {
-    dio_get_uint8(&din, (int *)&(packet->effect[inx].type));
-    dio_get_uint8(&din, (int *)&(packet->effect[inx].range));
-    dio_get_sint16(&din, &(packet->effect[inx].amount));
-    dio_get_uint8(&din, &(packet->effect[inx].survives));
-    dio_get_uint8(&din, &(packet->effect[inx].cond_bldg));
-    dio_get_uint8(&din, &(packet->effect[inx].cond_gov));
-    dio_get_uint8(&din, &(packet->effect[inx].cond_adv));
-    dio_get_uint8(&din, (int *)&(packet->effect[inx].cond_eff));
-    dio_get_uint8(&din, (int *)&(packet->effect[inx].aff_unit));
-    dio_get_uint8(&din, (int *)&(packet->effect[inx].aff_terr));
-    dio_get_uint16(&din, (int *)&(packet->effect[inx].aff_spec));
-  }
-  packet->effect[count].type = EFT_LAST;
+  dio_get_effects(&din, pc, &packet->effect);
+
   dio_get_uint8(&din, &packet->variant);	/* FIXME: remove when gen-impr obsoletes */
   dio_get_string(&din, packet->name, sizeof(packet->name));
   
@@ -2503,6 +2585,10 @@
   dio_put_string(&dout, packet->graphic_str);
   dio_put_string(&dout, packet->graphic_alt);
 
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_effects(&dout, pc, packet->effect);
+  }
+
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
     dio_put_string(&dout, packet->helptext);
@@ -2596,6 +2682,13 @@
   dio_get_string(&din, packet->graphic_str, sizeof(packet->graphic_str));
   dio_get_string(&din, packet->graphic_alt, sizeof(packet->graphic_alt));
   
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_effects(&din, pc, &packet->effect);
+  } else {
+    packet->effect = fc_malloc(sizeof(struct impr_effect));
+    packet->effect[0].type = EFT_LAST;
+  }
+
   len = dio_input_remaining(&din);
   if (len > 0) {
     packet->helptext = fc_malloc(len);
@@ -2646,6 +2739,9 @@
   }
   dio_put_uint8(&dout, packet->city_style);
   dio_put_tech_list(&dout, packet->init_techs);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_effects(&dout, pc, packet->effect);
+  }
   if (has_capability("class_legend", pc->capability)) {
     dio_put_string(&dout, packet->class);
     dio_put_string(&dout, packet->legend);
@@ -2683,6 +2779,9 @@
 
   dio_get_uint8(&din, &packet->city_style);
   dio_get_tech_list(&din, packet->init_techs);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_effects(&din, pc, &packet->effect);
+  }
   if (has_capability("class_legend", pc->capability)) {
     dio_get_string(&din, packet->class, sizeof(packet->class));
     dio_get_string(&din, packet->legend, sizeof(packet->legend));
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.h freeciv-patched/common/packets.h
--- freeciv-cvs/common/packets.h	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/packets.h	2003-06-30 12:18:03.000000000 +0100
@@ -368,6 +368,8 @@
   bool diplomat_investigate;
   int city_options;
   int turn_founded;
+
+  int buildflags, upkeep_free;
 };
 
 
@@ -566,6 +568,7 @@
   int sewer_size;
   int add_to_size_limit;
   int notradesize, fulltradesize;
+  int num_unit_flags;
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;
@@ -623,6 +626,7 @@
   int paratroopers_range; /* max range of paratroopers, F_PARATROOPERS */
   int paratroopers_mr_req;
   int paratroopers_mr_sub;
+  struct impr_effect *effect;
 
   /* Following is a pointer to malloced memory; on the server, it
      points to putype->helptext, malloced earlier; on the client,
@@ -775,6 +779,7 @@
   char graphic_str[MAX_LEN_NAME];
   char graphic_alt[MAX_LEN_NAME];
   
+  struct impr_effect *effect;
   char *helptext;		/* same as for packet_ruleset_unit, above */
 };
 
@@ -798,6 +803,7 @@
   bool leader_sex[MAX_NUM_LEADERS];
   int city_style;
   int init_techs[MAX_NUM_TECH_LIST];
+  struct impr_effect *effect;
   char class[MAX_LEN_NAME];
   char legend[MAX_LEN_MSG];
 };
@@ -854,6 +860,7 @@
   int diplcost,freecost,conquercost;
   int global_advances[A_LAST];
   int global_wonders[B_LAST];
+  int destroyed_owner[B_LAST];
   int foodbox;
   int techpenalty;
   bool spacerace;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/player.c freeciv-patched/common/player.c
--- freeciv-cvs/common/player.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/player.c	2003-06-30 12:18:03.000000000 +0100
@@ -25,6 +25,7 @@
 #include "government.h"
 #include "idex.h"
 #include "improvement.h"
+#include "log.h"
 #include "map.h"
 #include "mem.h"
 #include "rand.h"
@@ -66,7 +67,7 @@
 {
   return (TEST_BIT(pplayer->embassy, pplayer2->player_no)
           || (pplayer == pplayer2)
-          || (player_owns_active_wonder(pplayer, B_MARCO)
+          || (is_under_effect(B_LAST, NULL, pplayer, EFT_HAVE_EMBASSIES)
               && !is_barbarian(pplayer2)));
 }
 
@@ -130,14 +131,22 @@
 
   /* Initialise list of improvements with Player-wide equiv_range */
   improvement_status_init(plr->improvements, ARRAY_SIZE(plr->improvements));
+  /* Initialise vector of effects with player range. */
+  geff_vector_init(&plr->effects);
+  /* Initialise player's list of destroyed effects */
+  ceff_vector_init(&plr->destroyed_effects);
 
   /* Initialise list of improvements with Island-wide equiv_range */
   plr->island_improv = NULL;
+  plr->island_effects = NULL;
 
   if (map.num_continents > 0) {
     plr->island_improv = fc_malloc((map.num_continents + 1) * 
                                    game.num_impr_types * sizeof(Impr_Status));
+    plr->island_effects = fc_calloc(map.num_continents + 1,
+				    sizeof(struct geff_vector));
     for (i = 1; i <= map.num_continents; i++) {
+      geff_vector_init(&plr->island_effects[i]);
       improvement_status_init(&plr->island_improv[i * game.num_impr_types],
                               game.num_impr_types);
     }
@@ -314,18 +323,6 @@
 }
 
 /**************************************************************************
- ...
-**************************************************************************/
-bool player_owns_active_govchange_wonder(struct player *pplayer)
-{
-  return ( player_owns_active_wonder(pplayer, B_LIBERTY) ||
-	   ( (improvement_variant(B_PYRAMIDS)==1) &&
-	     player_owns_active_wonder(pplayer, B_PYRAMIDS) ) ||
-	   ( (improvement_variant(B_UNITED)==1) &&
-	     player_owns_active_wonder(pplayer, B_UNITED) ) );
-}
-
-/**************************************************************************
  Returns the number of techs the player has researched which has this
  flag. Needs to be optimized later (e.g. int tech_flags[TF_LAST] in
  struct player)
@@ -439,7 +436,7 @@
 struct city *find_palace(struct player *pplayer)
 {
   city_list_iterate(pplayer->cities, pcity) 
-    if (city_got_building(pcity, B_PALACE)) 
+    if (city_got_building(pcity, B_PALACE))
       return pcity;
   city_list_iterate_end;
   return NULL;
@@ -610,3 +607,38 @@
 {
   return TEST_BIT(me->gives_shared_vision, them->player_no);
 }
+
+void player_update_global_effects(struct player *pplayer)
+{
+  struct ceff_vector *ceff;
+  struct eff_city *eff;
+  int effind;
+
+  freelog(LOG_DEBUG, "player_update_global_effects: "
+          "player %s nation %s gov %s", pplayer->name,
+	  get_nation_name(pplayer->nation),
+	  get_government_name(pplayer->government));
+  ceff = &pplayer->destroyed_effects;
+
+  /* First, remove any existing effects */
+  for (effind = 0; effind < ceff_vector_size(ceff); ++effind) {
+    eff = ceff_vector_get(ceff, effind);
+
+    if (eff->impr == B_NATION || eff->impr == B_GOV) {
+      remove_global_effects(eff->impr, pplayer);
+      eff->impr = B_LAST;
+    }
+  }
+
+  ceff = &pplayer->destroyed_effects;
+
+  eff = append_ceff(ceff);
+  eff->impr = B_NATION;
+  eff->active = 0;
+  add_global_effects(eff->impr, pplayer);
+
+  eff = append_ceff(ceff);
+  eff->impr = B_GOV;
+  eff->active = 0;
+  add_global_effects(eff->impr, pplayer);
+}
